unit View.OrderList;

interface

uses
  System.SysUtils, System.Generics.Collections, System.Classes, JS, Web, WEBLib.Graphics, WEBLib.Controls,
  WEBLib.Forms, WEBLib.Dialogs, WEBLib.Menus, WEBLib.ExtCtrls, WEBLib.StdCtrls,
  WEBLib.JSON, Auth.Service, XData.Web.Client, WebLib.Storage,
  ConnectionModule, App.Types, Vcl.StdCtrls, Vcl.Controls, WEBLib.DBCtrls,
  Data.DB, XData.Web.JsonDataset, XData.Web.Dataset, WEBLib.DB, WEBLib.Grids,
  Vcl.Grids;

type
  TFOrderList = class(TWebForm)
    lblEntries: TWebLabel;
    lblEntries2: TWebLabel;
    edtSearch: TWebEdit;
    pnlMessage: TWebPanel;
    lblMessage: TWebLabel;
    btnCloseNotification: TWebButton;
    XDataWebClient1: TXDataWebClient;
    xdwdsCustomers: TXDataWebDataSet;
    wdsCustomers: TWebDataSource;
    xdwdsCustomersID: TIntegerField;
    xdwdsCustomersNAME: TStringField;
    xdwdsCustomersSHORT_NAME: TStringField;
    xdwdsCustomersADDRESS: TStringField;
    WebDBTableControl: TWebDBTableControl;
    cbCorrugatedPlate: TWebCheckBox;
    cbWebPlate: TWebCheckBox;
    edtCompanyName: TWebEdit;
    edtID: TWebEdit;
    btnConfirm: TWebButton;
    procedure WebFormShow(Sender: TObject);
    procedure WebDBTableControlGetCellChildren(Sender: TObject; ACol,
      ARow: Integer; AField: TField; AValue: string;
      AElement: TJSHTMLElementRecord);
    procedure cbCorrugatedPlateClick(Sender: TObject);
    procedure cbWebPlateClick(Sender: TObject);
  private
    //FJSONProc: TJSONProc;
    procedure AddRowToTable();
    procedure ClearTable();
    [async] procedure getCustomers();
  public
    class function CreateForm(AElementID: string): TWebForm;
  end;

var
  FOrderList: TFOrderList;

implementation

{$R *.dfm}

class function TFOrderList.CreateForm(AElementID: string): TWebForm;
begin
  Application.CreateForm(TFOrderList, AElementID, Result,
    procedure(AForm: TObject)
    begin
      with TFOrderList(AForm) do
      begin

      end;
    end
  );
end;

procedure TFOrderList.WebDBTableControlGetCellChildren(Sender: TObject; ACol,
  ARow: Integer; AField: TField; AValue: string;
  AElement: TJSHTMLElementRecord);
begin
  //WebDBTableControl.WidthStyle := TSizeStyle.ssAuto;
  console.log(AValue);
  WebDBTableControl.ColWidths[ACol] := AValue.Length * 12;
end;

procedure TFOrderList.WebFormShow(Sender: TObject);
begin
 getCustomers();
end;

procedure TFOrderList.cbCorrugatedPlateClick(Sender: TObject);
begin
  cbWebPlate.Checked := false;
end;

procedure TFOrderList.cbWebPlateClick(Sender: TObject);
begin
  cbCorrugatedPlate.Checked := false;
end;

procedure TFOrderList.ClearTable();
// clears the table
var
  tbody: TJSHTMLElement;
begin
  tbody := TJSHTMLElement(document.getElementById('tblCustomerGrid').getElementsByTagName('tbody')[0]);
  tbody.innerHTML := '';
end;

procedure TFOrderList.getCustomers();
var
  xdcResponse: TXDataClientResponse;
  customerList: TJSObject;
  data: TJSArray;
  i, count: integer;
  temp: TJSONObject;
  customer: TJSObject;
begin
    xdcResponse := await(XDataWebClient1.RawInvokeAsync('ILookupService.GetCustomers',
        []));
    customerList :=  TJSObject(xdcResponse.Result);
    data := TJSArray(customerList['data']);
    count := integer(customerList['count']);
    xdwdsCustomers.Close;
    xdwdsCustomers.SetJsonData(customerList['data']);
    xdwdsCustomers.Open;
end;

procedure TFOrderList.AddRowToTable();
var
  NewRow, Cell, P, Button, Audio: TJSHTMLElement;
  ClickHandler: TJSFunction;
  //strColorList: string;
  id: integer;
begin
  NewRow := TJSHTMLElement(document.createElement('tr'));
  //NewRow.Attrs['orderType'] := XDataWebDataSet1orderType.Value;
  NewRow.addEventListener('click', procedure
  begin
    //orderEntry(NewRow.Attrs['id'], 'EDIT');
  end);

  // Company ID Cell
  NewRow.Attrs['id'] := xdwdsCustomersID.AsString;
  Cell := TJSHTMLElement(document.createElement('td'));
  Cell.setAttribute('data-label', 'Order ID');
  if xdwdsCustomersID.AsString = '' then
    Cell.innerText := 'None'
  else
    Cell.innerText := xdwdsCustomersID.AsString;
  NewRow.appendChild(Cell);

  // Company Name Cell
  Cell := TJSHTMLElement(document.createElement('td'));
  Cell.setAttribute('data-label', 'Company Name');
  if xdwdsCustomersNAME.Value = '' then
    Cell.innerText := 'None'
  else
    Cell.innerText := xdwdsCustomersNAME.Value;
  NewRow.appendChild(Cell);

  // Short Name Cell
  Cell := TJSHTMLElement(document.createElement('td'));
  Cell.setAttribute('data-label', 'Job Name');
  if xdwdsCustomersSHORT_NAME.Value = '' then
    Cell.innerText := 'None'
  else
    Cell.innerText := xdwdsCustomersSHORT_NAME.Value;
  NewRow.appendChild(Cell);

  // Address Cell
  Cell := TJSHTMLElement(document.createElement('td'));
  Cell.setAttribute('data-label', 'Order Date');
  if xdwdsCustomersADDRESS.Value = '' then
    Cell.innerText := 'None'
  else
    Cell.innerText := xdwdsCustomersADDRESS.Value;
  NewRow.appendChild(Cell);

  // Appends new rows to the table body
  TJSHTMLElement(document.getElementById('tblCustomerGrid').getElementsByTagName('tbody')[0]).appendChild(NewRow);
end;

end.

